/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is cookiebutton.
 *
 * The Initial Developer of the Original Code is
 * Pang Lih Wuei (basic@mozdev.org).
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
window.addEventListener("load", function (e) 
{
	var doc     = this.document;
	var ifaces = Components.interfaces;
	
	var branch = Components.classes["@mozilla.org/preferences;1"]
			.getService(ifaces.nsIPrefService)
			.getBranch("extensions.cookiebutton.")
			.QueryInterface(ifaces.nsIPrefBranch)
			.QueryInterface(ifaces.nsIPrefBranchInternal);
	var showClear   = doc.getElementById("show-clear-cookies");
	var clearDeny   = doc.getElementById("clear-when-deny");
	var observer    =
	{
		_showClear     : showClear,
		_clearDeny     : clearDeny,
		_branch        : branch,
		QueryInterface : function (aIID) 
		{
			if (aIID.equals(Components.interfaces.nsIObserver) ||
				aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
				aIID.equals(Components.interfaces.nsISupports))
					return this;
			throw Components.results.NS_NOINTERFACE;
		},
		observe        : function (s, t, d) { this._update(); },
		_update        : function ()
		{
			this._showClear.checked = this._branch.getBoolPref("show-clear-cookies");
			this._clearDeny.checked = this._branch.getBoolPref("clear-when-deny");
		}
	};
	observer._update();
	branch.addObserver("show-clear-cookies",   observer, true);
	branch.addObserver("clear-when-deny",      observer, true);

	function boolPrefListener (pref_name) { this.pref_name = pref_name; }
	boolPrefListener.prototype =
	{
		branch: branch,
		handleEvent: function (e) { this.branch.setBoolPref(this.pref_name, e.target.checked); }
	};

	showClear.addEventListener("CheckboxStateChange",new boolPrefListener("show-clear-cookies"),   false);
	clearDeny.addEventListener("CheckboxStateChange",new boolPrefListener("clear-when-deny"),      false);

	try{doc.location = "chrome://cookiecontext-platform/content/options.xul";}catch(e){}
},false);
